using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Globalization;
using System.IO;
using Infragistics.Win.UltraWinExplorerBar;

namespace SampleGridApp
{
    public partial class Form1 : Form
    {
        private DataSet _dsData;
        private DataTable _dtTestbPrimary;
        private UltraGridRow bPrimaryRow;
        private UltraGridRow activeRow;
        public Form1()
        {
            InitializeComponent();
        }

        private void LoadStyles()
        {
            DataTable dtStyle = new DataTable("Style");
            dtStyle.Columns.Add("Name");
            dtStyle.Columns.Add("BarStyle", typeof(Infragistics.Win.UltraWinExplorerBar.UltraExplorerBarStyle));

            DataRow dRow = dtStyle.NewRow();
            dRow[0] = "ExplorerBar";
            dRow[1] = Infragistics.Win.UltraWinExplorerBar.UltraExplorerBarStyle.ExplorerBar;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "Listbar";
            dRow[1] = Infragistics.Win.UltraWinExplorerBar.UltraExplorerBarStyle.Listbar;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "Outlook Navigation Pane";
            dRow[1] = Infragistics.Win.UltraWinExplorerBar.UltraExplorerBarStyle.OutlookNavigationPane;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "Toolbox";
            dRow[1] = Infragistics.Win.UltraWinExplorerBar.UltraExplorerBarStyle.Toolbox;
            dtStyle.Rows.Add(dRow);

            dRow = dtStyle.NewRow();
            dRow[0] = "VisualStudio2005Toolbox";
            dRow[1] = Infragistics.Win.UltraWinExplorerBar.UltraExplorerBarStyle.VisualStudio2005Toolbox;
            dtStyle.Rows.Add(dRow);

            ultraComboEditor1.DisplayMember = "Name";
            ultraComboEditor1.ValueMember = "BarStyle";
            ultraComboEditor1.DataSource = dtStyle.DefaultView;
            ultraComboEditor1.SelectedIndex = 4;

        }
        private void ifgBtnLoad_Click(object sender, EventArgs e)
        {
            try
            {
                Cursor = Cursors.WaitCursor;
                LoadDataSet();
                ultraGrid1.DataSource = _dsData.Copy();
                
                //bPrimaryRow = ultraGrid1.Rows[0];
            }
            catch
            {
            }
            finally
            {
                Cursor = Cursors.Default;
            }
        }
        private void LoadDataSet()
        {
            _dsData = new DataSet();
            _dsData.ReadXml(Path.Combine(Application.StartupPath, "WorkOrderDetails.xml"));

            _dsData.Relations.Add("EIN_WO", _dsData.Tables[0].Columns["EINId"], _dsData.Tables[1].Columns["EINId"],false);
            //_dsData.Relations.Add("WO_TRAN", _dsData.Tables[1].Columns["RepairHistoryId"], _dsData.Tables[2].Columns["RepairHistoryId"]);

            //_dtTestbPrimary = new DataTable();
            //_dtTestbPrimary.Columns.Add("EIN");
            //_dtTestbPrimary.Columns.Add("bPrimary", typeof(bool));
            //_dtTestbPrimary.Columns["bPrimary"].DefaultValue = false;
            //DataRow newRow;
            //for (int rowIndex = 0; rowIndex < 5; rowIndex++)
            //{
            //    DataRow dRow = _dsData.Tables[0].Rows[rowIndex];
            //    newRow = _dtTestbPrimary.NewRow();
            //    newRow[0] = dRow["DecryptEINFLOC"];
            //    if (rowIndex == 0)
            //        newRow[1] = true;
            //    else
            //        newRow[1] = false;
            //    _dtTestbPrimary.Rows.Add(newRow);
            //}

        }

       
        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            



            //e.Layout.Override.AllowAddNew = AllowAddNew.TemplateOnBottom;
            e.Layout.Override.AllowRowFiltering = Infragistics.Win.DefaultableBoolean.True;
            //e.Layout.Override.SelectTypeRow = SelectType.ExtendedAutoDrag;
            e.Layout.Override.CellClickAction = CellClickAction.RowSelect;
            //e.Layout.Bands[0].Columns["bPrimary"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
            foreach (UltraGridBand ugBand in e.Layout.Bands)
            {
                foreach (UltraGridColumn ugColumn in ugBand.Columns)
                {
                    if (ugColumn.Key.Equals("bPrimary", StringComparison.InvariantCultureIgnoreCase))
                    {
                        ugColumn.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox;
                        ugColumn.CellActivation = Activation.AllowEdit;
                        ugColumn.DefaultCellValue = false;
                    }
                    else
                    {
                        //ugColumn.CellActivation = Activation.NoEdit;
                    }
                }
            }
            //e.Layout.Override.AllowUpdate = Infragistics.Win.DefaultableBoolean.False;
        }
        /// <summary>
        /// After sort change event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ugGrid_AfterSortChange(object sender, Infragistics.Win.UltraWinGrid.BandEventArgs e)
        {
            UltraGrid ugGrid = sender as UltraGrid; //Get the Ultra Grid Object
            if (ugGrid == null || ugGrid.ActiveRow == null) //Check the grid and Active row is present
                return;
            //ugGrid.ActiveRow.CollapseAll();
            //if (ugGrid.ActiveRow.IsGroupByRow)
            //    ugGrid.ActiveRow.Expanded = true;
            //ugGrid.ActiveRowScrollRegion.Scroll(RowScrollAction.Top);
            ugGrid.ActiveRowScrollRegion.ScrollRowIntoView(ugGrid.ActiveRow); //Set the scroll region into active row
        }

        private void ultraGrid1_AfterSelectChange(object sender, AfterSelectChangeEventArgs e)
        {
            if(ultraGrid1.Selected.Rows.Count>0)
                ultraGrid1.ActiveRowScrollRegion.ScrollRowIntoView(ultraGrid1.Selected.Rows[0]); //Set the scroll region into active row.ActiveRow); //Set the scroll region into active row
            //bool before = ultraGrid1.ActiveRow.HasRowSelectorAppearance;
           
            //bool after = ultraGrid1.ActiveRow.HasRowSelectorAppearance;
            ////ultraGrid1.ActiveRow.ResolveRowSelectorAppearance(ref appData);
        }

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            if (!e.Cell.Column.Key.Equals("bPrimary", StringComparison.InvariantCultureIgnoreCase))
                return;
            string ein = e.Cell.Row.Cells[0].Text;
            if (bool.Parse(e.Cell.Value.ToString()))
            {
                bPrimaryRow.Cells["bPrimary"].Value = true;
                //e.Cell.Value = true;
            }
            else
            {
                if (bPrimaryRow != null)
                    bPrimaryRow.Cells["bPrimary"].Value = false;

                bPrimaryRow = e.Cell.Row;

            }
            bPrimaryRow.Update();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
            LoadDataSet();
            ultraGrid1.DataSource = _dsData.Copy();           
            LoadStyles();
        }

        private void ultraGrid1_BeforeCellDeactivate(object sender, CancelEventArgs e)
        {
            if (ultraGrid1.ActiveCell == null)
                return;
            ultraGrid1.ActiveCell.Value = ultraGrid1.ActiveCell.Value.ToString().Trim();
        }

        private void ultraGrid1_BeforeExitEditMode(object sender, BeforeExitEditModeEventArgs e)
        {
            TrimSpacesInGridActiveCell(ultraGrid1);
        }

        /// <summary>
        /// TrimSpaces in Grid Active cell while exit from edit mode
        /// </summary>
        /// <param name="ugGrid">Set Ultrawingrid</param>
        public static void TrimSpacesInGridActiveCell(UltraGrid ugGrid)
        {
            if (ugGrid.ActiveCell == null || !ugGrid.ActiveCell.DataChanged || ugGrid.ActiveCell.Column.DataType != typeof(string) || (ugGrid.ActiveCell.Column.Style != Infragistics.Win.UltraWinGrid.ColumnStyle.Default && ugGrid.ActiveCell.Column.Style != Infragistics.Win.UltraWinGrid.ColumnStyle.DropDown))
                return;
            ugGrid.ActiveCell.Value = ugGrid.ActiveCell.Text.Trim();
        }        

        private void ultraExplorerBar1_ItemClick(object sender, Infragistics.Win.UltraWinExplorerBar.ItemEventArgs e)
        {
            MessageBox.Show("Load Item clicked");
        }

        private void ultraComboEditor1_ValueChanged(object sender, EventArgs e)
        {
            if(ultraComboEditor1.SelectedIndex>=0)
                ultraExplorerBar1.Style = (Infragistics.Win.UltraWinExplorerBar.UltraExplorerBarStyle)ultraComboEditor1.Value;

        }

        

        private void ultraGrid1_AfterRowActivate(object sender, EventArgs e)
        {
            if (ultraGrid1 == null || ultraGrid1.ActiveRow == null) //Check the grid and Active row is present
                return;

            SetActiveRowScrollPosition(ultraGrid1);


            
            //activeRow = ultraGrid1.ActiveRow;
        }

        private void ExpandParentRow(UltraGridRow ugRow)
        {
            
            if (ugRow.ParentRow != null)
            {
                ugRow.ParentRow.Expanded = true;
                ExpandParentRow(ugRow.ParentRow);
            }
            
        }

        /// <summary>
        /// SetActiveRowScrollPosition
        /// </summary>
        /// <param name="ugGrid">Set the UltraWingrid</param>
        public static void SetActiveRowScrollPosition(UltraGrid ugGrid)
        {
            if (ugGrid == null || ugGrid.ActiveRow == null) //Check the grid and Active row is present
                return;



            if (ugGrid.Selected.Rows.Count > 0)
                ugGrid.Selected.Rows.Clear();

            ugGrid.ActiveRow.Selected = true;
            ugGrid.ActiveRowScrollRegion.ScrollRowIntoView(ugGrid.ActiveRow); //Set the scroll region into active row

        }
        

        private void ultraGrid1_AfterRowFilterChanged(object sender, AfterRowFilterChangedEventArgs e)
        {
            SetActiveRowScrollPosition(ultraGrid1);
        }

        private void ultraExplorerBar1_MouseClick(object sender, MouseEventArgs e)
        {
            UltraExplorerBarItem uExpItem = ultraExplorerBar1.ItemFromPoint(e.Location);
            if (uExpItem == null)
                return;

            MessageBox.Show("Load Item clicked - " + uExpItem.Text);
        }

        private void ultraGrid1_BeforeSortChange(object sender, BeforeSortChangeEventArgs e)
        {
            e.ProcessMode = ProcessMode.Synchronous;

        }

        

               
    }
}